#include "../ecl/eclib.h"

/* copy a permutation, syntax like strcpy or memcpy */
#define permcpy(p1, p2) memcpy(p1, p2, PERMLEN);
#define NUM_MOVES 50
#define PATHLEN 1000

extern short permsize; /* size of permutations */
extern short pathlen;
extern short remap_mode;
/* nontrivial coset reps at level n, link lists */
extern struct list_perm cosrep[];
extern struct perm *idn; /* identity permutation */
/* the initial moves */
extern short num_moves, num_rots;
extern char movename[];
extern short *moveperm[];
extern short *rots[];

/* functions with non-integer returns */
extern struct perm *find_cosrep();

extern char opt_d;
extern char opt_q;
extern char opt_s;
struct list_connect {
struct connect *head, *tail;
short n_nodes;
};

struct connect {
struct connect *next, *last;

struct perm *strong; /* strong generator */
short given; /* a given generator */
short invert; /* 1 if you should invert this perm */

};

#define STRUCT_connect 0
#define get_connect() (struct connect *) ZC_get_struct(0)
#define copy_connect(s)  (struct connect *) ZC_copy_struct((char *)(s), 0)
#define free_connect(s)  ZC_free_struct((char *)(s), 0)
#define zap_list_connect(t) ZC_zap_list_gen((t), 0)
#define copy_list_connect(s,t) ZC_copy_list_gen((char *)(s), (char *)(t), 0)

#define RANGE_LOOP_connect(t, start, end) \
{ struct connect *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->next;
#define LOOP_connect(list, t) RANGE_LOOP_connect((t), (list)->head, 0)
#define BACK_RANGE_LOOP_connect(t, start, end) \
{ struct connect *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->last;
#define BACK_LOOP_connect(list, t) BACK_RANGE_LOOP_connect((t), (list)->tail, 0)
#define END_LOOP_connect } }
#define extract_connect(list, t) ZC_extract((list), (t), STRUCT_connect, 0)
#define extract_free_connect(list, t) ZC_extract((list), (t), STRUCT_connect, 1)
extern struct connect *ZC_insert_connect();
#define insert_connect(list, t,a0) ZC_insert_connect((list), (t), 0,a0)
#define copy_insert_connect(list, t,a0) ZC_insert_connect((list), (t), 1,a0)
extern struct connect *append_connect(),
	*copy_append_connect(),
	*prepend_connect(),
	*copy_prepend_connect();
extern struct list_connect  trail;
struct list_perm {
struct perm *head, *tail;
short n_nodes;
};

struct perm {
struct perm *next, *last;

#define PERMSIZE 96 /* max number of elements being permuted */
#define PERMLEN (sizeof(short) * permsize)
short p[PERMSIZE]; /* the permutation */
/* build this permutation from strong/given generators */
struct list_connect produce;
/* attribute bits */
#define CR_INGROUP 1 /* part of the group under consideration */
#define CR_NOTSEED 2 /* coset rep is more than just a seed */
#define CR_SUBGROUP 4 /* part of the subgroup being built */
#define CR_PENDING 8 /* pending generator */
short attrib; /* attributes */
/* it is not tremendously difficult to overflow this long, I don't check for this */
long tostart; /* length of path back to start */

};

#define STRUCT_perm 1
#define get_perm() (struct perm *) ZC_get_struct(1)
#define copy_perm(s)  (struct perm *) ZC_copy_struct((char *)(s), 1)
#define free_perm(s)  ZC_free_struct((char *)(s), 1)
#define zap_list_perm(t) ZC_zap_list_gen((t), 1)
#define copy_list_perm(s,t) ZC_copy_list_gen((char *)(s), (char *)(t), 1)

#define RANGE_LOOP_perm(t, start, end) \
{ struct perm *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->next;
#define LOOP_perm(list, t) RANGE_LOOP_perm((t), (list)->head, 0)
#define BACK_RANGE_LOOP_perm(t, start, end) \
{ struct perm *ZC_var1; \
for((t) = (start); (t) != (end); (t) = ZC_var1) { \
ZC_var1 = (t)->last;
#define BACK_LOOP_perm(list, t) BACK_RANGE_LOOP_perm((t), (list)->tail, 0)
#define END_LOOP_perm } }
#define extract_perm(list, t) ZC_extract((list), (t), STRUCT_perm, 0)
#define extract_free_perm(list, t) ZC_extract((list), (t), STRUCT_perm, 1)
extern struct perm *ZC_insert_perm();
#define insert_perm(list, t,a0) ZC_insert_perm((list), (t), 0,a0)
#define copy_insert_perm(list, t,a0) ZC_insert_perm((list), (t), 1,a0)
extern struct perm *append_perm(),
	*copy_append_perm(),
	*prepend_perm(),
	*copy_prepend_perm();
